<?php

use application\core\utils\Env;
use application\core\utils\Ibos;
use application\core\utils\Module;
use application\core\utils\StringUtil;
use application\core\utils\Model;
use application\modules\main\model\Setting;
use application\core\utils\Cache;
session_start();
error_reporting( NULL );
date_default_timezone_set( 'PRC' );
@set_time_limit( 1000 );
ini_set( 'display_errors', 'Off' );
@set_magic_quotes_runtime( 0 );

define( 'PATH_ROOT', dirname( __FILE__ ) . '/../' );
$defines = PATH_ROOT . '/system/defines.php';
define( 'TIMESTAMP', time() );
define( 'YII_DEBUG', true );
define( 'IN_DEBUG', true );
$yii = PATH_ROOT . '/library/yii.php';
$mainConfig = require_once PATH_ROOT . '/system/config/common.php';
require_once ( $defines );
require_once ( $yii );
Yii::setPathOfAlias( 'application', PATH_ROOT . DIRECTORY_SEPARATOR . 'system' );
Yii::createApplication( 'application\core\components\Application', $mainConfig );

//======================================更新数据开始=========================================

$act = isset( $_GET['act'] ) ? $_GET['act'] : 'updateStructure';
$allowActs = array( 'updateStructure', 'updateData', 'updateSuccess' );
if ( !in_array( $act, $allowActs ) ) {
    $act = 'updateStructure';
}

$limit = 50;
$fileName = 'update.php';

if ( $act == 'updateStructure' ) {
    $columnExist1 = Model::checkColumnExist( '{{crm_attachment}}', 'isele' );
    if( !empty( $columnExist1 ) ) {
        $sql_1 = "ALTER TABLE `{{crm_attachment}}`
ADD COLUMN `isele`  tinyint(1) UNSIGNED NOT NULL DEFAULT 0 COMMENT '是否是电子档，1是0否，默认0，表示普通附件';";
        Model::executeSqls( $sql_1 );
    }
    $sql_2 = "ALTER TABLE `{{notify_message}}`
MODIFY COLUMN `url`  varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '链接地址';";
    Model::executeSqls( $sql_2 );
    $columnExist2 = Model::checkColumnExist( '{{feed}}', 'roleid' );
    if( !empty( $columnExist2 ) ) {
        $sql_3 = "ALTER TABLE `{{feed}}`
ADD COLUMN `roleid`  text NOT NULL COMMENT '可见角色ID';";
        Model::executeSqls( $sql_3 );
    }
    $sql_4 = "ALTER TABLE `{{email_body}}`
MODIFY COLUMN `content`  mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '邮件内容';";
    Model::executeSqls( $sql_4 );
    $sql_5 = "ALTER TABLE `{{email_body_1}}`
MODIFY COLUMN `content`  mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '邮件内容';";
    Model::executeSqls( $sql_5 );
    $hasRow = Ibos::app()->db->createCommand()
        ->select()
        ->from( "{{auth_item}}" )
        ->where( " `name` = 'officialdoc/officialdoc/move' " )
        ->queryRow();
    if( empty( $hasRow ) ) {
        $sql_6 = "INSERT INTO `{{auth_item}}` (`name`, `type`, `description`, `bizrule`, `data`) VALUES ('officialdoc/officialdoc/move', '0', '', 'return UserUtil::checkDataPurv($purvId);', 's:0:\"\";');";
        Model::executeSqls( $sql_6 );
    }
    $hasRow = Ibos::app()->db->createCommand()
        ->select()
        ->from( "{{auth_item_child}}" )
        ->where( " `parent` = 1 AND `child` = 'officialdoc/officialdoc/move' " )
        ->queryRow();
    if( empty( $hasRow ) ) {
        $sql_7 = "INSERT INTO `{{auth_item_child}}` (`parent`, `child`) VALUES ('1', 'officialdoc/officialdoc/move');";
        Model::executeSqls( $sql_7 );
    }
    $sql_8 = "UPDATE `{{node}}` SET `routes`='officialdoc/officialdoc/edit,officialdoc/officialdoc/move' WHERE (`node`='edit' AND `module`='officialdoc');";
    Model::executeSqls( $sql_8 );
    $hasRow = Ibos::app()->db->createCommand()
        ->select()
        ->from( "{{auth_item}}" )
        ->where( " `name` = 'article/default/move' " )
        ->queryRow();
    if( empty( $hasRow ) ) {
        $sql_9 = "INSERT INTO `{{auth_item}}` (`name`, `type`, `description`, `bizrule`, `data`) VALUES ('article/default/move', '0', '', 'return UserUtil::checkDataPurv($purvId);', 's:0:\"\";');";
        Model::executeSqls( $sql_9 );
    }
    $hasRow = Ibos::app()->db->createCommand()
        ->select()
        ->from( "{{auth_item_child}}" )
        ->where( " `parent` = 1 AND `child` = 'article/default/move' " )
        ->queryRow();
    if( empty( $hasRow ) ) {
        $sql_10 = "INSERT INTO `{{auth_item_child}}` (`parent`, `child`) VALUES ('1', 'article/default/move');";
        Model::executeSqls( $sql_10 );
    }
    $sql_11 = "UPDATE `{{node}}` SET  `routes`='article/default/edit,article/default/move' WHERE (`node`='edit' AND `module`='article');";
    Model::executeSqls( $sql_11 );
    $msg = '更新数据完成，正在更新缓存......';
    redirect( '../index.php?r=dashboard/update/index', 3, $msg );
} elseif ( $act == 'updateSuccess' ) {

    Module::updateConfig();
    Cache::update();
    $msg = "恭喜。更新完成，请登录后台更新全局缓存";
    redirect( '../index.php?r=dashboard/update/index', 3, $msg );
}

//===================================函数start=================================

/**
 * 执行mysql.sql文件，创建数据表等
 * @param string $sql sql语句
 */
function executeSql( $sql ) {
    $sqls = String::splitSql( $sql );
    $command = Yii::app()->db->createCommand();
    if ( is_array( $sqls ) ) {
        foreach ( $sqls as $sql ) {
            if ( trim( $sql ) != '' ) {
                $command->setText( $sql )->execute();
            }
        }
    } else {
        $command->setText( $sqls )->execute();
    }
    return true;
}

/**
 * 获取url各个参数
 */
function getParams( $url ) {
    $refer_url = parse_url( $url );
    $params = $refer_url['query'];
    $arr = array();
    if ( !empty( $params ) ) {
        $paramsArr = explode( '&', $params );
        foreach ( $paramsArr as $k => $v ) {
            $a = explode( '=', $v );
            $arr[$a[0]] = $a[1];
        }
    }
    return $arr;
}

/**
 * 是否安装某个模块
 */
function getIsInstall( $module ) {
    $rs = Yii::app()->db->createCommand()
            ->select( 'module' )
            ->from( '{{module}}' )
            ->where( "`module` = '{$module}'" )
            ->queryScalar();
    return !!$rs;
}

/**
 * 判断某个模块是否可用
 */
function getIsEnabled( $module ) {
    $rs = Yii::app()->db->createCommand()
            ->select( 'module' )
            ->from( '{{module}}' )
            ->where( "`disabled` = 0 AND `module` = '{$module}'" )
            ->queryScalar();
    return !!$rs;
}

/**
 * URL重定向
 * @param string $url 重定向的URL地址
 * @param integer $time 重定向的等待时间（秒）
 * @param string $msg 重定向前的提示信息
 * @return void
 */
function redirect( $url, $time = 0, $msg = '' ) {
    //多行URL地址支持
    $url = str_replace( array( "\n", "\r" ), '', $url );
    if ( empty( $msg ) )
        $msg = "系统将在{$time}秒之后自动跳转到{$url}！";
    if ( !headers_sent() ) {
        // redirect
        if ( 0 === $time ) {
            header( 'Location: ' . $url );
        } else {
            header( "refresh:{$time};url={$url}" );
            Env::iExit( $msg );
        }
    } else {
        $str = "<meta http-equiv='Refresh' content='{$time};URL={$url}'>";
        if ( $time != 0 )
            $str .= $msg;
        Env::iExit( $str );
    }
}

/**
 * 建立文件夹
 *
 * @param string $aimUrl
 * @return viod
 */
function createDirs( $aimUrl ) {
    $aimUrl = str_replace( '', '/', $aimUrl );
    $aimDir = '';
    $arr = explode( '/', $aimUrl );
    $result = true;
    foreach ( $arr as $str ) {
        $aimDir .= $str . '/';
        if ( !file_exists( $aimDir ) ) {
            $result = mkdir( $aimDir );
        }
    }
    return $result;
}

/**
 * 删除文件
 *
 * @param string $aimUrl
 * @return boolean
 */
function unlinkFile( $aimUrl ) {
    if ( file_exists( $aimUrl ) ) {
        @unlink( $aimUrl );
        return true;
    } else {
        return false;
    }
}

/**
 * 删除文件夹
 *
 * @param string $aimDir
 * @return boolean
 */
function unlinkDir( $aimDir ) {
    $aimDir = str_replace( '', '/', $aimDir );
    $aimDir = substr( $aimDir, -1 ) == '/' ? $aimDir : $aimDir . '/';
    if ( !is_dir( $aimDir ) ) {
        return false;
    }
    $dirHandle = opendir( $aimDir );
    while ( false !== ($file = readdir( $dirHandle )) ) {
        if ( $file == '.' || $file == '..' ) {
            continue;
        }
        if ( !is_dir( $aimDir . $file ) ) {
            unlinkFile( $aimDir . $file );
        } else {
            unlinkDir( $aimDir . $file );
        }
    }
    closedir( $dirHandle );
    return rmdir( $aimDir );
}
